package net.seamist.web.filter;



import java.io.IOException;

import java.security.Principal;

import javax.servlet.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import net.seamist.web.SeamistConstants;


/**
 * The <code>AuthenticationFilter</code> is a type of <code>Filter</code> that
 * checks incomming requests, and determines if those requests are from
 * authenticated clients.
 *
 * @author Victor R. Cardona
 * @version $Revision: 1.2 $, $Date: 2004/03/31 17:01:40 $
 */
public final class AuthenticationFilter implements Filter {

    FilterConfig config;


    public void init(FilterConfig filterConfig) throws ServletException {
	config = filterConfig;
    }


    public void doFilter(ServletRequest request, 
			 ServletResponse response, 
			 FilterChain chain) throws IOException, ServletException {
	if (config == null) {
	    return;
	}

	HttpSession session = ((HttpServletRequest) request).getSession(false);

	if (session != null) {
	    Principal token = 
		(Principal) session.getAttribute(SeamistConstants.SESS_AUTH_TOKEN);
	    if (token != null) {
		chain.doFilter(request, response);
		return;
	    }
	}
	// Redirect the user to the login page.
	((HttpServletResponse) response).sendRedirect("/seamist/action/home");
    }


    public void destroy() {
    }

}
