package net.seamist.web.filter;

import java.security.Principal;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletRequestWrapper;
import javax.servlet.http.HttpSession;

import net.seamist.service.SeamistAuthenticationToken;

import net.seamist.web.SeamistConstants;




public final class SeamistHttpRequestWrapper extends HttpServletRequestWrapper {

    public SeamistHttpRequestWrapper(HttpServletRequest request) {
	super(request);
    }

    
    public String getRemoteUser() {
	HttpSession session = getSession(false);

	if (session != null) {
	    SeamistAuthenticationToken token = 
		(SeamistAuthenticationToken) session.getAttribute(SeamistConstants.SESS_AUTH_TOKEN);
	    
	    if (token != null) {
		return token.getName();
	    }
	}
	
	return null;
    }


    public Principal getUserPrincipal() {
	HttpSession session = getSession(false);
	SeamistAuthenticationToken token = null;

	if (session != null) {
	    token = (SeamistAuthenticationToken) session.getAttribute(SeamistConstants.SESS_AUTH_TOKEN);
	}

	return token;
    }


    public boolean isUserInRole(String role) {
	HttpSession session = getSession(false);

	if (session != null) {
	    SeamistAuthenticationToken token = 
		(SeamistAuthenticationToken) session.getAttribute(SeamistConstants.SESS_AUTH_TOKEN);

	    if (token != null) {
		return token.isUserInRole(role);
	    }
	}
	return false;
    }

}
